#include "caudat.cpp"
#include "cau_resource.h"
#include "sounds.h"
#include <sstream>





LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
char szClassName[ ] = "Cau_Exporter";

int WINAPI
WinMain (HINSTANCE hThisInstance,
         HINSTANCE hPrevInstance,
         LPSTR lpszArgument,
         int nCmdShow)

{
    
    MSG messages; 
    WNDCLASSEX wincl;
    
    HWND hSelectTpa, hExport, hMassEx;
    
     char Path[MAX_PATH];
     std::string getDrivePath;
     
     GetModuleFileName(NULL, Path, MAX_PATH);
     getDrivePath=Path;
     int truncate_path = getDrivePath.find_last_of("\\");
     getDrivePath.erase(truncate_path+1);   /* Retain full pathway  */

     cau_WaveFile=getDrivePath;
     temp_FileWav=getDrivePath;
    
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure; 
    wincl.style = CS_DBLCLKS; 
    wincl.cbSize = sizeof (WNDCLASSEX);

    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0; 
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

  
    if (!RegisterClassEx (&wincl))
        return 0;
  
    
    hwnd = CreateWindowEx (
           0, 
           szClassName, 
           "Cau_Exporter",
           WS_OVERLAPPEDWINDOW&~WS_MAXIMIZEBOX&~WS_THICKFRAME,
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           400,
           200, 
           HWND_DESKTOP,
           NULL,
           hThisInstance,
           NULL
           );
////////////////////////////////////////////////////////////////////////////////   
        
        hSelectTpa = CreateWindowEx(0,TEXT("BUTTON"),TEXT("Load_Tpa"),                      
        WS_CHILD| WS_VISIBLE | BS_PUSHBUTTON,
        280, 140, 90, 24,              
        hwnd, (HMENU) IDB_SELECT, GetModuleHandle(NULL),NULL);
        
        hExport = CreateWindowEx(0,TEXT("BUTTON"),TEXT("Export.Cau"),                      
        WS_CHILD| WS_VISIBLE | BS_PUSHBUTTON,
        120, 140, 90, 24,              
        hwnd, (HMENU) IDB_EXPORT, GetModuleHandle(NULL),NULL); 
        
        hMassEx = CreateWindowEx(0,TEXT("BUTTON"),TEXT("Export_All"),                      
        WS_CHILD| WS_VISIBLE | BS_PUSHBUTTON,
        20, 140, 90, 24,              
        hwnd, (HMENU) IDB_MASSEX, GetModuleHandle(NULL),NULL);             
        
////////////////////////////////////////////////////////////////////////////////              

    ShowWindow (hwnd, nCmdShow);

    while (GetMessage (&messages, NULL, 0, 0))
    {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }

    return messages.wParam;
}


LRESULT CALLBACK
WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message) 
    {
            case WM_DESTROY:
        
               if(tpaFile)
               {
                fclose(tpaFile);
               }
             
              PostQuitMessage (0); 
              break;
            
                   
            case WM_COMMAND:
            {
            
    switch(LOWORD(wParam))
     { 
			
			case IDB_SELECT:
			  playwav1();
			  Load_Tpa();
			  break;
			  
            case IDB_MASSEX:
               if(tpaFile){
                while(cauCount<Num_Of_Entries-2){
                ++cauCount;
                std::stringstream def;
                def<<cauCount;
                cau_WaveFile=temp_FileWav;
                cau_WaveFile+=def.str();
                cau_WaveFile+="cau.cau";
                Cau_Extract();
	             }
	             if(cauCount==Num_Of_Entries-2){
	              MessageBeep(0);
	              }
                }
	             else{
	               MessageBeep(0);
	             }
                break;
			  
	        case IDB_EXPORT:
	           if(tpaFile){
	            if(cauCount<Num_Of_Entries-2){
	          playwav1();
	          ++cauCount;
	          std::stringstream abc;
	          abc<<cauCount;
	          cau_WaveFile=temp_FileWav;
	          cau_WaveFile+=abc.str();
	          cau_WaveFile+="cau.cau";
	          Cau_Extract();
	          }
	           else{
	            MessageBeep(0);
	            }
	           }
	            else{
	            MessageBeep(0);
	            }
	          break;
			  
			  }
	         }
            
        default: 
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}
